// **************************************************
// *  CHOCO: an open-source Constraint Programming  *
// *     System for Research and Education          *
// *                                                *
// *    contributors listed in choco.Entity.java    *
// *           Copyright (C) F. Laburthe, 1999-2006 *
// **************************************************
package choco;

import java.util.logging.Logger;

/**
 * An overall root abstract class.
 */
public abstract class AbstractEntity implements Entity {
  /**
   * All objects may be linked to an external object
   */

  public Object hook = null;


  /**
   * The (optimization or decision) problem to which the entity belongs.
   */

  public AbstractProblem problem;

  protected AbstractEntity() {
    ;
  }

  protected AbstractEntity(AbstractProblem pb) {
    problem = pb;
  }

  /**
   * Retrieves the problem of the entity
   */

  public AbstractProblem getProblem() {
    return problem;
  }

  public String pretty() {
    return toString();
  }

}

