// **************************************************
// *  CHOCO: an open-source Constraint Programming  *
// *     System for Research and Education          *
// *                                                *
// *    contributors listed in choco.Entity.java    *
// *           Copyright (C) F. Laburthe, 1999-2006 *
// **************************************************
package choco.integer.search;

import choco.AbstractVar;
import choco.integer.IntDomainVar;
import choco.search.AbstractSearchHeuristic;

public abstract class AbstractIntVarSelector extends AbstractSearchHeuristic implements IIntVarSelector {

  /**
   * a specific array of IntVars from which the object seeks the one with smallest domain
   */
  protected IntDomainVar[] vars;

  /**
   * the IVarSelector can be asked to return a variable
   *
   * @return a variable on whose domain an alternative can be set (such as a non instantiated search variable)
   */
  public AbstractVar selectVar() {
    return (AbstractVar) selectIntVar();
  }
}
