// **************************************************
// *  CHOCO: an open-source Constraint Programming  *
// *     System for Research and Education          *
// *                                                *
// *    contributors listed in choco.Entity.java    *
// *           Copyright (C) F. Laburthe, 1999-2006 *
// **************************************************
package choco.integer.search;

import choco.integer.IntDomainVar;
import choco.search.IVarSelector;

/**
 * an interface for objects controlling the selection of an search variable (for heuristic purposes)
 */
public interface IIntVarSelector extends IVarSelector {
  /**
   * the IIntVarSelector can be asked to return an {@link choco.integer.var.IntDomainVarImpl}
   *
   * @return a non instantiated search variable
   */
  public IntDomainVar selectIntVar();
}
