// **************************************************
// *  CHOCO: an open-source Constraint Programming  *
// *     System for Research and Education          *
// *                                                *
// *    contributors listed in choco.Entity.java    *
// *           Copyright (C) F. Laburthe, 1999-2006 *
// **************************************************
package choco.integer.search;

import choco.integer.IntDomainVar;
import choco.util.IntIterator;

import java.util.Random;

public class RandomIntValSelector implements IValSelector {
  protected Random random;

  /**
   * Default constructor for a random value selector for banching.
   */
  public RandomIntValSelector() {
    random = new Random();
  }

  /**
   * Constructs a random value selector for branching with a specified seed.
   */
  public RandomIntValSelector(long seed) {
    random = new Random(seed);
  }

  public int getBestVal(IntDomainVar x) {
    int val = (random.nextInt(x.getDomainSize()));
    IntIterator iterator = x.getDomain().getIterator();
    for (int i = 1; i < val; i++) {
      iterator.next();
    }
    return iterator.next();
  }
}
