//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     PalmExplanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.real.explain;

import choco.AbstractProblem;
import choco.palm.dbt.explain.GenericExplanation;
import choco.palm.real.PalmRealVar;

/**
 * Abstract implementation of a real bound explanation.
 */
public abstract class AbstractRealBoundExplanation extends GenericExplanation
    implements RealBoundExplanation {
  /**
   * Previous value of the variable bound.
   */
  protected double previousValue;

  /**
   * Touched variable.
   */
  protected PalmRealVar variable;

  /**
   * Creates such an explanation for the specified problem.
   */
  public AbstractRealBoundExplanation(AbstractProblem pb) {
    super(pb);
  }

  /**
   * Returns the previous value of the variable bound.
   */
  public double getPreviousValue() {
    return previousValue;
  }

  /**
   * Returns the touched variable (the variable which this explanations explains the domain).
   */
  public PalmRealVar getVariable() {
    return variable;
  }
}
